if (typeof window !== null)
{
	try
	{
		if(window.opener.cyclone3xuladmin)
		{
			cyclone3xuladmin.gen_SOAPBroadcaster = window.opener.cyclone3xuladmin.gen_SOAPBroadcaster;
		}
	}
	catch(e)
	{
		log('[dialog.js] ' + e);
	}
}

var dialog_image_file_select = {
	'onload' : function(e)
	{
		try
		{
			window.resizeTo(920,690);
			document.getElementById('content').load_param.ID = window.arguments[1].ID;
			document.getElementById('content').fnc_reload();
			document.getElementById('content').addEventListener('click', dialog_image_file_select.fnc_click, false);
		}
		catch(e)
		{
			alert('[image_file_select.xul] {onload} ' + e);
		}
	},
	'ondialogaccept': function(e)
	{
		try
		{
			var selected=document.getElementById('view').get_selected();
			if (selected.ID_format !== '')
			{
				if (selected.ID)
				{
					log('return selected.ID_format='+selected.ID_format+' ID='+selected.ID+' src='+selected.src);
					window.arguments[1].returnFunction(
						{
							addon: 'a501',
							addon_type: 'image',
							src: selected.src.toString(),
							name: selected.name.toString(),
							ID: selected.ID.toString(),
							ID_format: selected.ID_format.toString(),
							ID_entity: selected.ID_entity.toString()
						}
					);
				}
			}
			else
			{
				return false;
			}
		}
		catch(e)
		{
			alert('[image_file_select.xul] {ondialogaccept} ' + e);
		}
	},
	'fnc_click': function (event)
	{
		var target = (event.originalTarget) ? event.originalTarget : event.target;
		
		if (target.localName === 'image' && event.button === 0)
		{
			var telem=document.getBindingParent(target);
			
			if (telem.localName == 'stack' && telem.tmpaddon)
			{
				var elem=document.getElementById('view');
				if (telem.folder != '')
				{
					
				}
				else
				{
					elem.load_param.ID = telem.ID;
					elem.load_param.ID_category = telem.ID_category;
					elem.fnc_reload();
				}
			}
			return
		}
		
		/* List */
		
		var xulNode = document.getAnonymousElementByAttribute(event.target,'IDanon','list');
		
		if (xulNode)
		{
			
			var clicked=event.target.get_clicked(event);
			
			clicked.addon = xulNode.getAttribute('addon').toString();
			
			clicked.addon_type = xulNode.getAttribute('addon_type').toString();
			
			clicked.tmpaddon = clicked.addon + '_' + clicked.addon_type;
			
			if(clicked.row>-1)
			{
				if(clicked.obj === ''){return;}
				if(clicked.obj == 'twisty'){return;}
				if(event.button===0)
				{
					if(clicked.col == 'name')
					{
						var elem=document.getElementById('view');
						
						if (clicked.ID.match(/^_/))
						{
							
						}
						else if (clicked.folder !== '')
						{
							
						}
						else
						{
							if (elem.load_param.ID != clicked.ID)
							{
								elem.load_param.ID = clicked.ID;
								elem.load_param.ID_category = clicked.ID_category;
								elem.fnc_reload();
							}
						}
					}
				}
				else if(event.button==2)
				{
				}
			}
			return;
		}
		
	}
};

var dialog_video_part_select = {
	'onload' : function(e)
	{
		try
		{
			window.resizeTo(610,560);
			document.getElementById('content').load_param.ID = window.arguments[1].ID;
			document.getElementById('content').fnc_reload();
			document.getElementById('content').addEventListener('click', dialog_video_part_select.fnc_click, false);
		}
		catch(e)
		{
			alert('[video_part_select.xul] {onload} ' + e);
		}
	},
	'ondialogaccept': function(e)
	{
		try
		{
			var selected=document.getElementById('view').get_selected();
			if (selected.ID)
			{
				log('return selected.folder='+selected.folder+' ID='+selected.ID+' ID_entity='+selected.ID_entity+' name='+selected.name);
				window.arguments[1].returnFunction(
					{
						addon: 'a510',
						addon_type: 'video_part',
						thumbnail: selected.thumbnail,
						original: selected.original,
						name: selected.name,
						ID: selected.ID,
						ID_entity: selected.ID_entity
					}
				);
			}
			else
			{
				return false;
			}
			
		}
		catch(e)
		{
			alert('[video_part_select.xul] {ondialogaccept} ' + e);
		}
	},
	'fnc_click': function(event)
	{
		log('clicked!');
		
		var target = (event.originalTarget) ? event.originalTarget : event.target;
		
		if (target.localName == 'image' && event.button === 0)
		{
			var telem=document.getBindingParent(target);
			
			if (telem.localName == 'stack' && telem.tmpaddon)
			{
				var elem=document.getElementById('view');
				if (telem.folder !== '')
				{
					
				}
				else
				{
					log('selected ID=' + telem.ID + ' ID_entity='+telem.ID_entity);
					elem.load_param.ID = telem.ID;
					elem.load_param.ID_entity = telem.ID_entity;
					elem.load_param.ID_category = telem.ID_category;
					elem.fnc_reload()
				}
			}
			return
		}
		
		/* List */
		
		var xulNode = document.getAnonymousElementByAttribute(event.target,'IDanon','list');
		
		if (xulNode)
		{
			var clicked=event.target.get_clicked(event);
			
			clicked.addon = xulNode.getAttribute('addon').toString();
			
			clicked.addon_type = xulNode.getAttribute('addon_type').toString();
			
			clicked.tmpaddon = clicked.addon + '_' + clicked.addon_type;
			
			if(clicked.row>-1)
			{
				if(clicked.obj === ''){return;}
				if(clicked.obj == 'twisty'){return;}
				if(event.button === 0)
				{
					if(clicked.col == 'name')
					{
						
						var elem=document.getElementById('view');
						
						if (clicked.ID.match(/^_/))
						{
							
						}
						else if (clicked.folder != '')
						{
							
						}
						else
						{
							if (elem.load_param.ID != clicked.ID)
							{
								log('selected ID=' + clicked.ID + ' ID_entity='+clicked.ID_entity)
								elem.load_param.ID = clicked.ID;
								elem.load_param.ID_entity = clicked.ID_entity;
								elem.load_param.ID_category = clicked.ID_category;
								elem.fnc_reload()
							}
						}
						
					}
				}
				else if(event.button==2)
				{
				}
			}
			return;
		}
	}
};

var dialog_input_attributes = {
	'universal' : [
		'class',
		'id',
		'style',
		'dir'
	],
	'list' : {
		'A': ['href','target'],
		'IMG': ['src','alt','border','width','height', 'event'],
		'DIV': ['columns']
	},
	'onload' : function(e)
	{
		try
		{
			window.resizeTo(450,400);
			dialog_input_attributes.setValues(window.arguments[1].element_tagname, window.arguments[1].attribute_list);
		}
		catch(e)
		{
			alert('[input_attributes.xul] {onload} ' + e);
		}
	},
	'ondialogaccept': function(e)
	{
		try
		{
			var value_editor = document.getElementById('value_editor');
			window.arguments[2].accept = 1;
			
			window.arguments[2].attribute_list = dialog_input_attributes.getParticular(window.arguments[1].element_tagname);
			
			var value_editor_attribute_list = value_editor.value;
			
			for (a in value_editor_attribute_list)
			{
				window.arguments[2].attribute_list[a] = value_editor_attribute_list[a];
			}
		}
		catch(e)
		{
			alert('[input_attributes.xul] {ondialogaccept} ' + e);
		}
	},
	'setValues' : function (element_tagname, attribute_list)
	{
		var mylist;
		
		if (dialog_input_attributes.list[element_tagname])
		{
			mylist = dialog_input_attributes.universal.concat(dialog_input_attributes.list[element_tagname]); 
		}
		else
		{
			mylist = dialog_input_attributes.universal;
		}
		
		particular_list = new Array(); 
		
		// split the attribute list to particular and general for this tag
		
		// set empty values to particular list - for particular attrs
		for (var i in mylist)
		{
			particular_list[mylist[i]] = '';
		}
		
		for (a in attribute_list)
		{
			for (var i in mylist)
			{
				if (mylist[i] == a)
				{
					particular_list[a] = attribute_list[a];
					delete attribute_list[a];
				}
			}	
		}
		
		// set rows and inputboxes visible and set their values, set elementt tag label
		
		dialog_input_attributes.setParticular(element_tagname, particular_list);
		
		// set general attributes to the attribute editor
		
		var value_editor = document.getElementById('value_editor');
		value_editor.value = attribute_list;
	},
	
	'setParticular' : function(element_tagname, particular_list)
	{
		document.getElementById('element_label').setAttribute('value', '<' + element_tagname + '>');
			
		for (a in particular_list)
		{
			var row = document.getElementById('row_' + a);
			var field = document.getElementById('field_' + a);
			
			if (row) {row.setAttribute('hidden', 'false');}
			
			if (a == 'readonly')
			{
				if (particular_list[a] == 'true' && field) 
				{
					field.setAttribute('checked', 'true');
				}
				
				continue;
			}
			
			if (field) {field.value = particular_list[a];}
		}
	},
	
	'getParticular' : function (element_tagname)
	{
		var mylist;
		var output_list = new Array();
		
		if (dialog_input_attributes.list[element_tagname])
		{
			mylist = dialog_input_attributes.universal.concat(dialog_input_attributes.list[element_tagname]); 
		}
		else
		{
			mylist = dialog_input_attributes.universal;
		}
		
		for (var i in mylist)
		{
			var field = document.getElementById('field_' + mylist[i]);
			
			if (field)
			{
				if (mylist[i] == 'readonly')
				{
					if (field.getAttribute('checked') == 'true')
					{
						output_list[mylist[i]] = 'true';
					}
					else
					{
						output_list[mylist[i]] = 'false';
					}
				}
				else
				{
					output_list[mylist[i]] = field.value;
				}
			}
		}
		
		return output_list;
	}
};

var dialog_login = {
	'onload' : function(e)
	{
		try
		{
			/*
			document.getElementById("statusbar-icon").setAttribute("class","busy");
			document.getElementById("statusbar-text").value=ui.locale.getStringFromName("window.login.checking_upgrade");
			*/
			
			register.loadExtensions();
			
			/* window.sizeToContent(); */
			/* window.resizeTo(310,370); */
			var mvX=((window.screen.availWidth-window.outerWidth)/2);
			var mvY=((window.screen.availHeight-window.outerHeight)/2);
			window.moveTo(mvX, mvY);
			
			core.getInstalledVersion("c3xuladmin4@cyclone3.org", 
				function(addon)
				{
					document.getElementById("statusbar-version").value = Services.appinfo.version + "/" + addon.version;
				}
			);
			
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			
			/* 
				const_Cyclone3XULAdminPrefsRoot
			*/
			
		}
		catch(e)
		{
			alert("[login.xul] {onload} " + e);
		}
	}
};

var dialog_googlemaps = {
	'changeTimer' : null,
	
	// xul window init functions
	'init': function()
	{
		try{
			// hook up an event handler to the iframe - the html map will notify us
			// that pointer position has changed
			
			// then we can read global variables v_longitude and v_latitude from the html and update xul accordingly
			
			var maps_frame = document.getElementById('maps_frame');
/*
			var doc = document.implementation.createDocument("http://www.w3.org/1999/xhtml","html",null);
			doc = doc.firstChild;
			doc.setAttribute('xmlns', 'http://www.w3.org/1999/xhtml');
			doc.setAttribute('flex', '1');
			//doc.setAttribute('id', 'maps_frame');
			
			var head = document.createElementNS('http://www.w3.org/1999/xhtml', 'head');

			var script2 = document.createElement('script');
			script2.setAttribute('type', 'text/javascript');
			script2.setAttribute('src', 'chrome://c3xuladmin/content/js/googlemaps.js');
			
			maps_frame.contentDocument.head.appendChild(script2);
			
			var script1 = document.createElement('script');
			script1.setAttribute('type', 'text/javascript');
			script1.setAttribute('src', 'http://maps.googleapis.com/maps/api/js?v=3&sensor=false&callback=initialize');
			
			maps_frame.contentDocument.head.appendChild(script1);

			doc.appendChild(head);
			
			var body = document.createElementNS('http://www.w3.org/1999/xhtml', 'body');
			body.setAttribute('onload','initialize();');
			
			var frame = document.createElementNS('http://www.w3.org/1999/xhtml', 'div');
			frame.id = 'map_canvas';
			frame.style = 'width: 250px; height: 200px; border: 10px red solid';
			
			body.appendChild(frame);
			
			doc.appendChild(body);
			
			maps_frame.contentDocument.documentElement.replaceWith(doc);
			
			console.log(maps_frame);
			console.log('---');
			console.log(maps_frame.contentWindow);
			console.log(maps_frame.contentWindow.wrappedJSObject.initialize);
			console.log('---');
*/
			//console.log(maps_frame.contentDocument.documentElement.innerHTML);
			
			var script = maps_frame.contentDocument.createElement("script");
			script.setAttribute("type", "text/javascript");
			script.setAttribute("src", "http://maps.googleapis.com/maps/api/js?v=3&sensor=false");
			maps_frame.contentDocument.getElementsByTagName("head")[0].appendChild(script);
			
			//console.log(maps_frame.contentDocument);
			
			maps_frame.contentDocument.addEventListener(
				"change",
				function(evt) {
					dialog_googlemaps.changed(evt);
				},
				true
			);
			
			/*dialog_googlemaps.changeTimer = window.setInterval(
				function(evt) {
					dialog_googlemaps.changed(evt);
				},
				300
			);*/
			
			maps_frame.contentWindow.prefillSetup(window.arguments[1]);
			
			if (window.arguments[1])
			{
				if (window.arguments[1].lng)
				{
					if (window.arguments[1].lat)
					{
						console.log('initial coordinates defined, set input values and stuff ...');
						//maps_frame.contentWindow.wrappedJSObject.setCoords(window.arguments[1].lng, window.arguments[1].lat);
						
						document.getElementById('latitude_decimal').value = window.arguments[1].lat;
						document.getElementById('longitude_decimal').value = window.arguments[1].lng;
						//alert(window.arguments[1].lat + ' ' + window.arguments[1].lng);
					}
				} else
				{
					if (window.arguments[1].helpstring)
					{
						console.log('initial string address defined, set input values and stuff ...');
						//maps_frame.contentWindow.wrappedJSObject.searchLocation(window.arguments[1].helpstring);
						document.getElementById('text').value = window.arguments[1].helpstring;
					}
				}
			}
			
			if (window.arguments[1].helpstring)
			{
				document.getElementById('text').value = window.arguments[1].helpstring;
			}
			
		}catch(e){log('[googlemaps.xul] {init} ' + e);}
	},
	'changed' : function(evt)
	{
		var maps_frame = document.getElementById('maps_frame');
		
		var lng = maps_frame.contentWindow.wrappedJSObject.v_longitude;
		var lat = maps_frame.contentWindow.wrappedJSObject.v_latitude;
		var address = maps_frame.contentWindow.wrappedJSObject.v_address;
		var address_object = maps_frame.contentWindow.wrappedJSObject.v_address_object;
			
		document.getElementById('latitude_decimal').value = lat;
		document.getElementById('longitude_decimal').value = lng;
		
		if (address)
		{
			document.getElementById('text').value = address;
		}
		
		if (address_object)
		{
			window.arguments[1].address_object = address_object;
		}
	},
	'keyDown': function(evt)
	{
		console.log('keyDown ' + document.getElementById('text').value);
		if (evt.keyCode == 13)
		{
			evt.preventDefault();
			evt.stopPropagation();
			dialog_googlemaps.searchtext();
		}
		else
		{
			return true;
		}
	},
	'searchtext': function()
	{
		// is called after a text is entered into the searchfield
			
		var myval = document.getElementById('text').value; // get value from the textbox
		var maps_frame = document.getElementById('maps_frame'); // get iframe object
		
		// a javascript call within the iframe to search for the string
		maps_frame.contentWindow.wrappedJSObject.textSearch(myval);
	},
	'onload' : function()
	{
		try
		{
			dialog_googlemaps.init();
			window.resizeTo(600,550);
		}
		catch(e)
		{
			log('[googlemaps.xul] {onload} ' + e);
		}
	},
	'ondialogaccept' : function()
	{
		try
		{
			if (window.arguments[1])
			{
				window.arguments[1].set = 1;
				window.arguments[1].lat = document.getElementById('latitude_decimal').value;
				window.arguments[1].lng = document.getElementById('longitude_decimal').value;
				window.arguments[1].address = document.getElementById('text').value;
				window.arguments[1].copy_address = document.getElementById('copy_address').getAttribute('checked').toString();
			}
			
		}
		catch(e)
		{
			alert('[googlemaps.xul] {ondialogaccept} ' + e);
		}
	}
};

var dialog_upload = {
	'onclose' : function()
	{
		try{
			var uobject = window.arguments[1].var_parent_object;
			var upid = window.arguments[1].var_upload_id;
			
			if(uobject.arr_uploads[upid])
			{
				uobject.arr_uploads[upid].abort();
				delete uobject.arr_uploads[upid];
				uobject.var_uploads_count--;
				window.close();
			}
		}
		catch(e)
		{
			alert('[upload.xul] {onload} ' + e);
		}
	},
	'onload' : function()
	{
		try
		{
			var waiting = ui.locale.getStringFromName('window.upload.waiting');
			var upcomplete = ui.locale.getStringFromName('window.upload.complete');
			
			var interval = setInterval(
				function ()
				{
					var progress = document.getElementById('themeter');
					var complete = document.getElementById('thelabel');
					var working = document.getElementById('working');
					
					var loaded = window.arguments[0].loaded;
					var size = window.arguments[0].size;
					
					var percent = 0;
					if (size > 0)
						percent = (loaded/size)*100;
					else if (size === 0) 
						percent = 0;	
						
					if (percent > 99)
					{
						progress.setAttribute('value',100);
						complete.setAttribute('value',waiting);
						document.title = 'Upload: 100% '+ window.arguments[1].var_filename;
						working.setAttribute('hidden','false');
					} else
					{
						percent = parseInt(percent);
						
						if (loaded > 1048576)
						{
							loaded = loaded/1048576;
							loaded = loaded.toPrecision(3);
							loaded += ' MB';
						} else
						{
							loaded = parseInt(loaded/1024) + ' kB';
						}
						
						progress.setAttribute('value',percent + 1);
						complete.setAttribute('value',loaded + ' (' + percent + '%)');
						document.title = 'Upload: ' + percent + '% '+ window.arguments[1].var_filename;
					}
					
					if (window.arguments[0].finished)
					{
						if (window.arguments[0].finished == 1)
						{
							if ( dialog_upload.keepOpen() )
							{
								var mybutton = document.getElementById('closebutton');
								mybutton.setAttribute('label', 'OK');
								mybutton.addEventListener('click', function(){ window.close(); }, false);
								
								progress.setAttribute('value',100);
								complete.setAttribute('value',upcomplete);
								document.title = 'Upload: 100% '+ window.arguments[1].var_filename;
								working.setAttribute('hidden','true');
								
							}
							else
							{
								window.close();
							}
						}
					}
				},
				300
			);
			
			document.getElementById('filename').setAttribute('value', window.arguments[1].var_filename);
			
			window.sizeToContent();
		}
		catch(e)
		{
			alert('[upload.xul] {onload} ' + e);
		}
	},
	'keepOpen' : function()
	{
		var keep_open = document.getElementById('keepopen');
		
		if (keep_open.hasAttribute('checked'))
		{
			if (keep_open.getAttribute('checked') == 'true')
			{
				return true;
			}
		}
		else
		{
			return false;
		}
	}
};

var dialog_cleanup = {
	// xul window init functions
	'init': function()
	{
		try{
			
		}catch(e){alert('[dialog_cleanup.xul] {} ' + e);}
	},
	'onload' : function()
	{
		try
		{
			window.sizeToContent();
			console.log(window.arguments);
		}
		catch(e)
		{
			alert('[dialog_cleanup.xul] {onload} ' + e);
		}
	},
	'process' : function(cleanupMode)
	{
		try
		{
			window.arguments[2].mode = cleanupMode;
			window.close();
		}
		catch(e)
		{
			alert('[dialog_cleanup.xul] {ondialogaccept} ' + e);
		}
	}
};